config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  root to: 'activities#index'
  get '/activities', to: redirect('/')
  resources :actors, only: [:index, :show] do
    collection do
      get :lookup, to: 'actors#lookup'
    end
    resources :activities, only: [:index]
  end
  get :feed, to: 'activities#feed'
  resources :followings, only: [:create, :destroy] do
    collection do
      post :follow, to: 'followings#follow'
    end

    member do
      put :accept, to: 'followings#accept'
    end
  end
  resources :notes
  resources :users, except: [:new, :create, :destroy]

  get '/.well-known/webfinger', to: 'web_finger#find', as: :webfinger
  get '/.well-known/host-meta', to: 'web_finger#host_meta', as: :host_meta
  get '/.well-known/nodeinfo', to: 'web_finger#node_info', as: :node_info
  get '/nodeinfo/2.0', to: 'web_finger#show_node_info', as: :show_node_info

  namespace :federation do
    resources :actors, only: [:show] do
      member do
        get :followers
        get :following
      end
      get :outbox, to: 'activities#outbox'
      post :inbox, to: 'activities#create'
      resources :activities, only: [:show]
      resources :followings, only: [:show]
      resources :notes, only: [:show]
    end
  end
end

app/models/following.rb
class Following < ApplicationRecord
  include Routeable

  enum status: { pending: 0, accepted: 1 }

  validates :target_actor_id, uniqueness: { scope: [:actor_id, :target_actor_id] }

  belongs_to :actor
  belongs_to :target_actor, class_name: 'Actor'
  # FIXME: Handle this with something like undelete
  has_many :activities, as: :entity, dependent: :destroy

  after_create :create_activity
  after_destroy :destroy_activity

  scope :with_actor, ->(actor) { where(actor_id: actor.id).or(where(target_actor_id: actor.id)) }

  def federated_url
    attributes['federated_url'].presence || federation_actor_following_url(actor_id: actor_id, id: id)
  end

  def accept!
    update! status: :accepted
    Activity.create! actor: target_actor, action: 'Accept', entity: self
  end

  class << self
    def new_from_account(account, actor:)
      target_actor = Actor.find_or_create_by_account account
      new actor: actor, target_actor: target_actor
    end
  end

  private

  def create_activity
    Activity.create! actor: actor, action: 'Create', entity: self
  end

  def destroy_activity
    Activity.create! actor: actor, action: 'Undo', entity: self
  end
end

app/controllers/federation/followings_controller.rb
module Federation
  class FollowingsController < FederationApplicationController
    before_action :set_following, only: [:show]

    # GET /federation/actors/1/followings/1.json
    def show; end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_following
      @following = Following.find_by!(actor_id: params[:actor_id], id: params[:id])
      authorize @following
    end
  end
end

app/controllers/followings_controller.rb
class FollowingsController < ApplicationController
  before_action :authenticate_user!
  before_action :set_following, only: [:accept, :destroy]

  def accept
    respond_to do |format|
      if @following.accept!
        format.html { redirect_to current_user, notice: I18n.t('controller.followings.accept.success') }
        format.json { render :show, status: :ok, location: @following }
      else
        format.html { redirect_to current_user, alert: I18n.t('controller.followings.accept.error') }
        format.json { render json: @following.errors, status: :unprocessable_entity }
      end
    end
  end

  # POST /followings
  # POST /followings.json
  def create
    @following       = Following.new(following_params)
    @following.actor = current_user.actor
    authorize @following

    save_and_render
  end

  # POST /followings/follow
  # POST /followings/follow.json
  def follow
    begin
      @following = Following.new_from_account following_account_params, actor: current_user.actor
      authorize @following
    rescue ActiveRecord::RecordNotFound
      # Renders a 422 instead of a 404
      respond_to do |format|
        format.html { redirect_to current_user, alert: I18n.t('controller.followings.follow.error') }
        format.json { render json: { target_actor: ['does not exist'] }, status: :unprocessable_entity }
      end

      return
    end

    save_and_render
  end

  # DELETE /followings/1
  # DELETE /followings/1.json
  def destroy
    @following.destroy
    respond_to do |format|
      format.html { redirect_to current_user, notice: I18n.t('controller.followings.destroy.success') }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_following
    @following = Following.find(params[:id])
    authorize @following
  end

  # Only allow a list of trusted parameters through.
  def following_params
    params.require(:following).permit(:target_actor_id)
  end

  def following_account_params
    params.require(:account)
  end

  def save_and_render
    respond_to do |format|
      if @following.save
        format.html { redirect_to current_user, notice: I18n.t('controller.followings.save_and_render.success') }
        format.json { render :show, status: :created, location: @following }
      else
        format.html { redirect_to current_user, alert: I18n.t('controller.followings.save_and_render.error') }
        format.json { render json: @following.errors, status: :unprocessable_entity }
      end
    end
  end
end

app/views/followings/_follow.html.haml
%div
  %b= link_to following.target_actor.name, following.target_actor
  (#{following.target_actor.at_address}) (#{following.status})

app/views/followings/_follower.html.haml
%div
  %b= link_to following.actor.name, following.actor
  (#{following.actor.at_address}) (#{following.status})
  - if following.pending? && following.target_actor == current_user.actor
    = button_to 'Accept', accept_following_path(following), method: :put

app/views/followings/_form.html.haml
= form_for following do |f|
  - if following.errors.any?
    .error_explanation
      %h2 #{pluralize(following.errors.count, 'error')} prohibited this following from being saved:
      %ul
        - following.errors.full_messages.each do |message|
          %li= message

  .field
    = f.label :target_actor
    = f.collection_select :target_actor_id, Actor.all, :id, :name
  .actions
    = f.submit 'Save'

app/views/followings/index.html.haml
%h1 Listing followings

%table
  %thead
    %tr
      %th Actor
      %th Target actor
      %th Status
      %th
      %th
      %th

  %tbody
    - @followings.each do |following|
      %tr
        %td= following.actor
        %td= following.target_actor
        %td= following.status
        %td= link_to 'Show', following
        %td= link_to 'Edit', edit_following_path(following)
        %td= link_to 'Destroy', following, method: :delete, data: { confirm: 'Are you sure?' }

%br

= link_to 'New Following', new_following_path

app/views/followings/show.html.haml
%p#notice= notice

%p
  %b Actor:
  = @following.actor
%p
  %b Target actor:
  = @following.target_actor
%p
  %b Status:
  = @following.status

= link_to 'Edit', edit_following_path(@following)
\|
= link_to 'Back', followings_path